#include <bits/stdc++.h>
#define maxn 200004

using namespace std;

vector<int> a, b;
int x[maxn];
int main()
{
    int n, q, t;
    cin >> n >> q;
    for(int i=0;i<n;i++)
    {
        cin >> t; a.push_back(t);
        if(i%2==1) b.push_back(a[i]&a[i-1]);
    }
    for(int i=0;i<q;i++)
    {
        int l, r, f;
        cin >> l >> r; f=a[l-1];
        for(int j=l;j<r;j++) f=f&a[j];
        x[i]=f;
    }
    for(int i=0;i<q;i++) cout << x[i] << endl;
    return 0;
}